diff --git a/usr.sbin/sdpd/lan.c b/usr.sbin/sdpd/lan.c
index 1cd054f3ff..82b1457dd0 100644
--- a/usr.sbin/sdpd/lan.c
+++ b/usr.sbin/sdpd/lan.c
@@ -1,6 +1,3 @@
-/* $NetBSD: lan.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/lan.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * lan.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: lan.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/lan.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: lan.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/lan.c 177358 2008-03-18 18:21:39Z emax $
  */
 
 #include <arpa/inet.h>
@@ -89,12 +86,12 @@ lan_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_lan_profile_p	lan = (sdp_lan_profile_p) provider->data;
 
 	return (rfcomm_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &lan->server_channel, 1));
+			(uint8_t const *) &lan->server_channel, 1)); 
 }
 
 static int32_t
@@ -102,16 +99,11 @@ lan_profile_create_service_availability(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_lan_profile_p	lan = (sdp_lan_profile_p) provider->data;
 
-	if (buf + 2 > eob)
-		return (-1);
-
-	SDP_PUT8(SDP_DATA_UINT8, buf);
-	SDP_PUT8(lan->load_factor, buf);
-
-	return (2);
+	return (common_profile_create_service_availability(buf, eob,
+			&lan->load_factor, 1));
 }
 
 static int32_t
@@ -119,7 +111,7 @@ lan_profile_create_ip_subnet(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_lan_profile_p	lan = (sdp_lan_profile_p) provider->data;
 	char			net[32];
 	int32_t			len;
@@ -141,7 +133,7 @@ lan_profile_create_ip_subnet(
 static int32_t
 lan_profile_data_valid(uint8_t const *data, uint32_t datalen)
 {
-	sdp_lan_profile_t const *lan = (sdp_lan_profile_t const *) data;
+	sdp_lan_profile_p	lan = (sdp_lan_profile_p) data;
 
 	if (lan->server_channel < 1 ||
 	    lan->server_channel > 30 ||
@@ -171,16 +163,10 @@ static attr_t	lan_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t lan_profile_uuids[] = {
-	SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-};
-
 profile_t	lan_profile_descriptor = {
-	lan_profile_uuids,
-	sizeof(lan_profile_uuids),
+	SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP,
 	sizeof(sdp_lan_profile_t),
 	lan_profile_data_valid,
 	(attr_t const * const) &lan_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/log.c b/usr.sbin/sdpd/log.c
index 33f9bf10ab..54aff4a785 100644
--- a/usr.sbin/sdpd/log.c
+++ b/usr.sbin/sdpd/log.c
@@ -1,6 +1,3 @@
-/* $NetBSD: log.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/log.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * log.c
  *
@@ -28,16 +25,14 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: log.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/log.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: log.c,v 1.1 2004/01/07 23:15:00 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/log.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/types.h>
 #include <stdarg.h>
 #include <syslog.h>
 
-#include "log.h"
-
 void
 log_open(char const *prog, int32_t log2stderr)
 {
@@ -129,3 +124,4 @@ log_debug(char const *message, ...)
 	vsyslog(LOG_DEBUG, message, ap);
 	va_end(ap);
 }
+
diff --git a/usr.sbin/sdpd/log.h b/usr.sbin/sdpd/log.h
index 5c829661c1..2ba3ba1ed4 100644
--- a/usr.sbin/sdpd/log.h
+++ b/usr.sbin/sdpd/log.h
@@ -1,6 +1,3 @@
-/* $NetBSD: log.h,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/log.h,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * log.h
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: log.h,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/log.h,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: log.h,v 1.1 2004/01/07 23:15:00 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/log.h 124758 2004-01-20 20:48:26Z emax $
  */
 
 #ifndef _LOG_H_
@@ -37,13 +34,14 @@
 
 void	log_open	(char const *prog, int32_t log2stderr);
 void	log_close	(void);
-void	log_emerg	(char const *message, ...) __printflike(1, 2);
-void	log_alert	(char const *message, ...) __printflike(1, 2);
-void	log_crit	(char const *message, ...) __printflike(1, 2);
-void	log_err		(char const *message, ...) __printflike(1, 2);
-void	log_warning	(char const *message, ...) __printflike(1, 2);
-void	log_notice	(char const *message, ...) __printflike(1, 2);
-void	log_info	(char const *message, ...) __printflike(1, 2);
-void	log_debug	(char const *message, ...) __printflike(1, 2);
+void	log_emerg	(char const *message, ...);
+void	log_alert	(char const *message, ...);
+void	log_crit	(char const *message, ...);
+void	log_err		(char const *message, ...);
+void	log_warning	(char const *message, ...);
+void	log_notice	(char const *message, ...);
+void	log_info	(char const *message, ...);
+void	log_debug	(char const *message, ...);
 
 #endif /* ndef _LOG_H_ */
+
diff --git a/usr.sbin/sdpd/main.c b/usr.sbin/sdpd/main.c
index 50da99a716..054a0fc872 100644
--- a/usr.sbin/sdpd/main.c
+++ b/usr.sbin/sdpd/main.c
@@ -1,6 +1,3 @@
-/* $NetBSD: main.c,v 1.3 2007/03/18 15:53:55 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/main.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * main.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: main.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/main.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: main.c,v 1.8 2004/01/13 19:31:54 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/main.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/select.h>
@@ -54,7 +51,7 @@
 
 #define	SDPD			"sdpd"
 
-static int32_t	drop_root	(char const *user, char const *group);
+static int32_t 	drop_root	(char const *user, char const *group);
 static void	sighandler	(int32_t s);
 static void	usage		(void);
 
@@ -69,12 +66,11 @@ main(int argc, char *argv[])
 {
 	server_t		 server;
 	char const		*control = SDP_LOCAL_PATH;
-	char const		*user = "_sdpd", *group = "_sdpd";
-	char const		*sgroup = NULL;
+	char const		*user = "nobody", *group = "nobody";
 	int32_t			 detach = 1, opt;
 	struct sigaction	 sa;
 
-	while ((opt = getopt(argc, argv, "c:dG:g:hu:")) != -1) {
+	while ((opt = getopt(argc, argv, "c:dg:hu:")) != -1) {
 		switch (opt) {
 		case 'c': /* control */
 			control = optarg;
@@ -84,10 +80,6 @@ main(int argc, char *argv[])
 			detach = 0;
 			break;
 
-		case 'G': /* super group */
-			sgroup = optarg;
-			break;
-
 		case 'g': /* group */
 			group = optarg;
 			break;
@@ -120,19 +112,19 @@ main(int argc, char *argv[])
 	    sigaction(SIGHUP,  &sa, NULL) < 0 ||
 	    sigaction(SIGINT,  &sa, NULL) < 0) {
 		log_crit("Could not install signal handlers. %s (%d)",
-			strerror(errno), errno);
+			strerror(errno), errno); 
 		exit(1);
 	}
 
 	sa.sa_handler = SIG_IGN;
 	if (sigaction(SIGPIPE, &sa, NULL) < 0) {
 		log_crit("Could not install signal handlers. %s (%d)",
-			strerror(errno), errno);
+			strerror(errno), errno); 
 		exit(1);
 	}
 
 	/* Initialize server */
-	if (server_init(&server, control, sgroup) < 0)
+	if (server_init(&server, control) < 0)
 		exit(1);
 
 	if ((user != NULL || group != NULL) && drop_root(user, group) < 0)
@@ -234,10 +226,10 @@ usage(void)
 "Where options are:\n" \
 "	-c	specify control socket name (default %s)\n" \
 "	-d	do not detach (run in foreground)\n" \
-"	-G grp	allow privileges to group\n" \
 "	-g grp	specify group\n" \
 "	-h	display usage and exit\n" \
 "	-u usr	specify user\n",
 		SDPD, SDP_LOCAL_PATH);
 	exit(255);
 }
+
diff --git a/usr.sbin/sdpd/nap.c b/usr.sbin/sdpd/nap.c
new file mode 100644
index 0000000000..d8b76c0e97
--- /dev/null
+++ b/usr.sbin/sdpd/nap.c
@@ -0,0 +1,209 @@
+/*
+ * nap.c
+ */
+
+/*-
+ * Copyright (c) 2008 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: nap.c,v 1.1 2008/03/11 00:02:42 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/nap.c 177358 2008-03-18 18:21:39Z emax $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <sdp.h>
+#include <string.h>
+#include "profile.h"
+#include "provider.h"
+
+static int32_t
+nap_profile_create_service_class_id_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t	service_classes[] = {
+		SDP_SERVICE_CLASS_NAP
+	};
+
+	return (common_profile_create_service_class_id_list(
+			buf, eob,
+			(uint8_t const *) service_classes,
+			sizeof(service_classes)));
+}
+
+static int32_t
+nap_profile_create_bluetooth_profile_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t	profile_descriptor_list[] = {
+		SDP_SERVICE_CLASS_NAP,
+		0x0100
+	};
+
+	return (common_profile_create_bluetooth_profile_descriptor_list(
+			buf, eob,
+			(uint8_t const *) profile_descriptor_list,
+			sizeof(profile_descriptor_list)));
+}
+
+static int32_t
+nap_profile_create_service_name(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static char	service_name[] = "Network Access Point";
+
+	return (common_profile_create_string8(
+			buf, eob,
+			(uint8_t const *) service_name, strlen(service_name)));
+}
+
+static int32_t
+nap_profile_create_service_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static char	service_descr[] = "Personal Ad-hoc Network Service";
+
+	return (common_profile_create_string8(
+			buf, eob,
+			(uint8_t const *) service_descr,
+			strlen(service_descr)));
+}
+
+static int32_t
+nap_profile_create_protocol_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data; 
+	sdp_nap_profile_p	nap = (sdp_nap_profile_p) provider->data; 
+
+	return (bnep_profile_create_protocol_descriptor_list(
+			buf, eob, (uint8_t const *) &nap->psm,
+			sizeof(nap->psm))); 
+}
+
+static int32_t
+nap_profile_create_security_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data; 
+	sdp_nap_profile_p	nap = (sdp_nap_profile_p) provider->data; 
+
+	return (bnep_profile_create_security_description(buf, eob,
+			(uint8_t const *) &nap->security_description,
+			sizeof(nap->security_description)));
+}
+
+static int32_t
+nap_profile_create_net_access_type(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data; 
+	sdp_nap_profile_p	nap = (sdp_nap_profile_p) provider->data; 
+
+	if (buf + 3 > eob)
+		return (-1);
+
+	SDP_PUT8(SDP_DATA_UINT16, buf);
+	SDP_PUT16(nap->net_access_type, buf);
+
+	return (3);
+}
+
+static int32_t
+nap_profile_create_max_net_access_rate(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data; 
+	sdp_nap_profile_p	nap = (sdp_nap_profile_p) provider->data; 
+
+	if (buf + 3 > eob)
+		return (-1);
+
+	SDP_PUT8(SDP_DATA_UINT16, buf);
+	SDP_PUT16(nap->max_net_access_rate, buf);
+
+	return (3);
+}
+
+static int32_t
+nap_profile_create_service_availability(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data; 
+	sdp_nap_profile_p	nap = (sdp_nap_profile_p) provider->data; 
+
+	return (common_profile_create_service_availability(buf, eob,
+			&nap->load_factor, 1));
+}
+
+static int32_t
+nap_profile_data_valid(uint8_t const *data, uint32_t datalen)
+{
+	sdp_nap_profile_p	nap = (sdp_nap_profile_p) data;
+
+	return ((nap->psm == 0)? 0 : 1);
+}
+
+static attr_t	nap_profile_attrs[] = {
+	{ SDP_ATTR_SERVICE_RECORD_HANDLE,
+	  common_profile_create_service_record_handle },
+	{ SDP_ATTR_SERVICE_CLASS_ID_LIST,
+	  nap_profile_create_service_class_id_list },
+	{ SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST,
+	  nap_profile_create_protocol_descriptor_list },
+	{ SDP_ATTR_LANGUAGE_BASE_ATTRIBUTE_ID_LIST,
+	  common_profile_create_language_base_attribute_id_list },
+	{ SDP_ATTR_SERVICE_AVAILABILITY,
+	  nap_profile_create_service_availability },
+	{ SDP_ATTR_BLUETOOTH_PROFILE_DESCRIPTOR_LIST,
+	  nap_profile_create_bluetooth_profile_descriptor_list },
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET, 
+	  nap_profile_create_service_name },
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET, 
+	  nap_profile_create_service_description },
+	{ SDP_ATTR_SECURITY_DESCRIPTION, 
+	  nap_profile_create_security_description },
+	{ SDP_ATTR_NET_ACCESS_TYPE, 
+	  nap_profile_create_net_access_type },
+	{ SDP_ATTR_MAX_NET_ACCESS_RATE, 
+	  nap_profile_create_max_net_access_rate },
+	{ 0, NULL } /* end entry */
+};
+
+profile_t	nap_profile_descriptor = {
+	SDP_SERVICE_CLASS_NAP,
+	sizeof(sdp_nap_profile_t),
+	nap_profile_data_valid,
+	(attr_t const * const) &nap_profile_attrs
+};
+
diff --git a/usr.sbin/sdpd/opush.c b/usr.sbin/sdpd/opush.c
index 24c8a30b81..bd20e74bef 100644
--- a/usr.sbin/sdpd/opush.c
+++ b/usr.sbin/sdpd/opush.c
@@ -1,6 +1,3 @@
-/* $NetBSD: opush.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/opush.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * opush.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: opush.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/opush.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: opush.c,v 1.6 2004/01/13 19:31:54 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/opush.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
@@ -87,12 +84,12 @@ opush_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_opush_profile_p	opush = (sdp_opush_profile_p) provider->data;
 
 	return (obex_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &opush->server_channel, 1));
+			(uint8_t const *) &opush->server_channel, 1)); 
 }
 
 static int32_t
@@ -100,7 +97,7 @@ opush_profile_create_supported_formats_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_opush_profile_p	opush = (sdp_opush_profile_p) provider->data;
 
 	return (obex_profile_create_supported_formats_list(
@@ -127,17 +124,10 @@ static attr_t	opush_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t opush_profile_uuids[] = {
-	SDP_SERVICE_CLASS_OBEX_OBJECT_PUSH,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-	SDP_UUID_PROTOCOL_OBEX,
-};
-
 profile_t	opush_profile_descriptor = {
-	opush_profile_uuids,
-	sizeof(opush_profile_uuids),
+	SDP_SERVICE_CLASS_OBEX_OBJECT_PUSH,
 	sizeof(sdp_opush_profile_t),
 	obex_profile_data_valid,
 	(attr_t const * const) &opush_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/panu.c b/usr.sbin/sdpd/panu.c
new file mode 100644
index 0000000000..f477c4bc19
--- /dev/null
+++ b/usr.sbin/sdpd/panu.c
@@ -0,0 +1,172 @@
+/*
+ * panu.c
+ */
+
+/*-
+ * Copyright (c) 2008 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: panu.c,v 1.1 2008/03/11 00:02:42 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/panu.c 177364 2008-03-19 00:06:30Z emax $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <sdp.h>
+#include <string.h>
+#include "profile.h"
+#include "provider.h"
+
+static int32_t
+panu_profile_create_service_class_id_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t	service_classes[] = {
+		SDP_SERVICE_CLASS_PANU
+	};
+
+	return (common_profile_create_service_class_id_list(
+			buf, eob,
+			(uint8_t const *) service_classes,
+			sizeof(service_classes)));
+}
+
+static int32_t
+panu_profile_create_bluetooth_profile_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t	profile_descriptor_list[] = {
+		SDP_SERVICE_CLASS_PANU,
+		0x0100
+	};
+
+	return (common_profile_create_bluetooth_profile_descriptor_list(
+			buf, eob,
+			(uint8_t const *) profile_descriptor_list,
+			sizeof(profile_descriptor_list)));
+}
+
+static int32_t
+panu_profile_create_service_name(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static char	service_name[] = "Personal Ad-hoc User Service";
+
+	return (common_profile_create_string8(
+			buf, eob,
+			(uint8_t const *) service_name, strlen(service_name)));
+}
+
+static int32_t
+panu_profile_create_service_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static char	service_descr[] =
+				"Personal Ad-hoc User Service";
+
+	return (common_profile_create_string8(
+			buf, eob,
+			(uint8_t const *) service_descr,
+			strlen(service_descr)));
+}
+
+static int32_t
+panu_profile_create_protocol_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data;
+	sdp_panu_profile_p	panu = (sdp_panu_profile_p) provider->data;
+
+	return (bnep_profile_create_protocol_descriptor_list(
+			buf, eob, (uint8_t const *) &panu->psm,
+			sizeof(panu->psm))); 
+}
+
+static int32_t
+panu_profile_data_valid(uint8_t const *data, uint32_t datalen)
+{
+	sdp_panu_profile_p	panu = (sdp_panu_profile_p) data;
+
+	return ((panu->psm == 0)? 0 : 1);
+}
+
+static int32_t
+panu_profile_create_service_availability(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data;
+	sdp_panu_profile_p	panu = (sdp_panu_profile_p) provider->data;
+
+	return (common_profile_create_service_availability( buf, eob,
+			&panu->load_factor, 1));
+}
+
+static int32_t
+panu_profile_create_security_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data;
+	sdp_panu_profile_p	panu = (sdp_panu_profile_p) provider->data;
+
+	return (bnep_profile_create_security_description(buf, eob,
+			(uint8_t const *) &panu->security_description,
+			sizeof(panu->security_description)));
+}
+
+static attr_t	panu_profile_attrs[] = {
+	{ SDP_ATTR_SERVICE_RECORD_HANDLE,
+	  common_profile_create_service_record_handle },
+	{ SDP_ATTR_SERVICE_CLASS_ID_LIST,
+	  panu_profile_create_service_class_id_list },
+	{ SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST,
+	  panu_profile_create_protocol_descriptor_list },
+	{ SDP_ATTR_LANGUAGE_BASE_ATTRIBUTE_ID_LIST,
+	  common_profile_create_language_base_attribute_id_list },
+	{ SDP_ATTR_SERVICE_AVAILABILITY,
+	  panu_profile_create_service_availability },
+	{ SDP_ATTR_BLUETOOTH_PROFILE_DESCRIPTOR_LIST,
+	  panu_profile_create_bluetooth_profile_descriptor_list },
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET, 
+	  panu_profile_create_service_name },
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET, 
+	  panu_profile_create_service_description },
+	{ SDP_ATTR_SECURITY_DESCRIPTION, 
+	  panu_profile_create_security_description },
+	{ 0, NULL } /* end entry */
+};
+
+profile_t	panu_profile_descriptor = {
+	SDP_SERVICE_CLASS_PANU,
+	sizeof(sdp_panu_profile_t),
+	panu_profile_data_valid,
+	(attr_t const * const) &panu_profile_attrs
+};
+
diff --git a/usr.sbin/sdpd/profile.c b/usr.sbin/sdpd/profile.c
index c1d33a5d16..bc6773e04a 100644
--- a/usr.sbin/sdpd/profile.c
+++ b/usr.sbin/sdpd/profile.c
@@ -1,9 +1,8 @@
-/* $NetBSD: profile.c,v 1.4 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/profile.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * profile.c
- *
+ */
+
+/*-
  * Copyright (c) 2004 Maksim Yevmenkin <m_evmenkin@yahoo.com>
  * All rights reserved.
  *
@@ -28,12 +27,11 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: profile.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/profile.c,v 1.2 2004/07/28 07:15:44 kan Exp $
+ * $Id: profile.c,v 1.6 2004/01/13 19:31:54 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/profile.c 177358 2008-03-18 18:21:39Z emax $
  */
 
 #include <sys/queue.h>
-#include <sys/utsname.h>
 #include <bluetooth.h>
 #include <sdp.h>
 #include <string.h>
@@ -49,30 +47,32 @@ profile_get_descriptor(uint16_t uuid)
 {
 	extern	profile_t	dun_profile_descriptor;
 	extern	profile_t	ftrn_profile_descriptor;
-	extern  profile_t	hf_profile_descriptor;
-	extern  profile_t	hset_profile_descriptor;
 	extern	profile_t	irmc_profile_descriptor;
 	extern	profile_t	irmc_command_profile_descriptor;
 	extern	profile_t	lan_profile_descriptor;
 	extern	profile_t	opush_profile_descriptor;
 	extern	profile_t	sp_profile_descriptor;
+	extern	profile_t	nap_profile_descriptor;
+	extern	profile_t	gn_profile_descriptor;
+	extern	profile_t	panu_profile_descriptor;
 
 	static const profile_p	profiles[] = {
 		&dun_profile_descriptor,
 		&ftrn_profile_descriptor,
-		&hf_profile_descriptor,
-		&hset_profile_descriptor,
 		&irmc_profile_descriptor,
 		&irmc_command_profile_descriptor,
 		&lan_profile_descriptor,
 		&opush_profile_descriptor,
-		&sp_profile_descriptor
+		&sp_profile_descriptor,
+		&nap_profile_descriptor,
+		&gn_profile_descriptor,
+		&panu_profile_descriptor
 	};
 
 	int32_t			i;
 
 	for (i = 0; i < sizeof(profiles)/sizeof(profiles[0]); i++)
-		if (profiles[i]->uuid[0] == uuid)
+		if (profiles[i]->uuid == uuid)
 			return (profiles[i]);
 
 	return (NULL);
@@ -85,7 +85,7 @@ profile_get_descriptor(uint16_t uuid)
 profile_attr_create_p
 profile_get_attr(const profile_p profile, uint16_t attr)
 {
-	attr_t const	*ad = (attr_t const *) profile->attrs;
+	attr_p	ad = (attr_p) profile->attrs;
 
 	for (; ad->create != NULL; ad ++)
 		if (ad->attr == attr)
@@ -107,7 +107,7 @@ common_profile_create_service_record_handle(
 		return (-1);
 
 	SDP_PUT8(SDP_DATA_UINT32, buf);
-	SDP_PUT32(((provider_t const *) data)->handle, buf);
+	SDP_PUT32(((provider_p) data)->handle, buf);
 
 	return (5);
 }
@@ -156,7 +156,7 @@ common_profile_create_bluetooth_profile_descriptor_list(
 		uint8_t const *data, uint32_t datalen)
 {
 	int32_t	len = 8 * (datalen >>= 2);
-
+	
 	if (len <= 0 || len > 0xff || buf + 2 + len > eob)
 		return (-1);
 
@@ -202,15 +202,15 @@ common_profile_create_language_base_attribute_id_list(
 	SDP_PUT8(SDP_DATA_UINT16, buf);
 	SDP_PUT16(((0x65 << 8) | 0x6e), buf);
 
-	/*
-	 * Encoding. Recommended is UTF-8. ISO639 UTF-8 MIBenum is 106
+	/* 
+	 * Encoding. Recommended is UTF-8. ISO639 UTF-8 MIBenum is 106 
 	 * (http://www.iana.org/assignments/character-sets)
 	 */
 
 	SDP_PUT8(SDP_DATA_UINT16, buf);
 	SDP_PUT16(106, buf);
 
-	/*
+	/* 
 	 * Offset (Primary Language Base is 0x100)
 	 */
 
@@ -221,7 +221,7 @@ common_profile_create_language_base_attribute_id_list(
 }
 
 /*
- * Use Operating System name as provider name
+ * Common provider name is "FreeBSD"
  */
 
 int32_t
@@ -229,16 +229,11 @@ common_profile_create_service_provider_name(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	struct utsname u;
-	char const *name;
-
-	if (uname(&u) < 0)
-		name = "Unknown";
-	else
-		name = u.sysname;
+	char	provider_name[] = "FreeBSD";
 
 	return (common_profile_create_string8(buf, eob,
-			(uint8_t const *)name, strlen(name)));
+			(uint8_t const *) provider_name,
+			strlen(provider_name)));
 }
 
 /*
@@ -260,6 +255,24 @@ common_profile_create_string8(
 	return (2 + datalen);
 }
 
+/*
+ * Service Availability
+ */
+
+int32_t
+common_profile_create_service_availability(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	if (datalen != 1 || buf + 2 > eob)
+		return (-1);
+
+	SDP_PUT8(SDP_DATA_UINT8, buf);
+	SDP_PUT8(data[0], buf);
+
+	return (2);
+}
+
 /*
  * seq8 len8			- 2 bytes
  *	seq8 len8		- 2 bytes
@@ -364,6 +377,16 @@ obex_profile_create_supported_formats_list(
 	return (2 + len);
 }
 
+/*
+ * do not check anything
+ */
+
+int32_t
+common_profile_always_valid(uint8_t const *data, uint32_t datalen)
+{
+	return (1);
+}
+
 /*
  * verify server channel number (the first byte in the data)
  */
@@ -378,14 +401,14 @@ common_profile_server_channel_valid(uint8_t const *data, uint32_t datalen)
 }
 
 /*
- * verify server channel number and supported_formats_size
+ * verify server channel number and supported_formats_size 
  * sdp_opush_profile and sdp_irmc_profile
  */
 
 int32_t
 obex_profile_data_valid(uint8_t const *data, uint32_t datalen)
 {
-	sdp_opush_profile_t const *opush = (sdp_opush_profile_t const *) data;
+	sdp_opush_profile_p	opush = (sdp_opush_profile_p) data;
 
 	if (opush->server_channel < 1 ||
 	    opush->server_channel > 30 ||
@@ -395,3 +418,80 @@ obex_profile_data_valid(uint8_t const *data, uint32_t datalen)
 
 	return (1);
 }
+
+/*
+ * BNEP protocol descriptor
+ */
+
+int32_t
+bnep_profile_create_protocol_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	/* supported protocol types */
+	uint16_t	 ptype[] = {
+		0x0800,	/* IPv4 */
+		0x0806,	/* ARP */
+#ifdef INET6
+		0x86dd,	/* IPv6 */
+#endif
+	};
+
+	uint16_t	 i, psm, version = 0x0100,
+			 nptypes = sizeof(ptype)/sizeof(ptype[0]),
+			 nptypes_size = nptypes * 3;
+
+	if (datalen != 2 || 18 + nptypes_size > 255 ||
+	    buf + 20 + nptypes_size > eob)
+		return (-1);
+
+	memcpy(&psm, data, sizeof(psm));
+
+	SDP_PUT8(SDP_DATA_SEQ8, buf);
+	SDP_PUT8(18 + nptypes_size, buf);
+
+	SDP_PUT8(SDP_DATA_SEQ8, buf);
+	SDP_PUT8(6, buf);
+	SDP_PUT8(SDP_DATA_UUID16, buf);
+	SDP_PUT16(SDP_UUID_PROTOCOL_L2CAP, buf);
+	SDP_PUT8(SDP_DATA_UINT16, buf);
+	SDP_PUT16(psm, buf);
+	
+	SDP_PUT8(SDP_DATA_SEQ8, buf);
+	SDP_PUT8(8 + nptypes_size, buf);
+	SDP_PUT8(SDP_DATA_UUID16, buf);
+	SDP_PUT16(SDP_UUID_PROTOCOL_BNEP, buf);
+	SDP_PUT8(SDP_DATA_UINT16, buf);
+	SDP_PUT16(version, buf);
+	SDP_PUT8(SDP_DATA_SEQ8, buf);
+	SDP_PUT8(nptypes_size, buf);
+	for (i = 0; i < nptypes; i ++) {
+		SDP_PUT8(SDP_DATA_UINT16, buf);
+		SDP_PUT16(ptype[i], buf);
+	}
+
+	return (20 + nptypes_size);
+}
+
+/*
+ * BNEP security description
+ */
+
+int32_t
+bnep_profile_create_security_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	uint16_t	security_descr;
+
+	if (datalen != 2 || buf + 3 > eob)
+		return (-1);
+
+	memcpy(&security_descr, data, sizeof(security_descr));
+
+	SDP_PUT8(SDP_DATA_UINT16, buf);
+	SDP_PUT16(security_descr, buf);
+
+        return (3);
+}
+
